summaryrefslogtreecommitdiff
path: root/tests/tail-2/infloop-1.sh
diff options
context:
space:
mode:
authorStefano Lattarini <stefano.lattarini@gmail.com>2012-08-30 14:13:12 +0200
committerJim Meyering <meyering@redhat.com>2012-08-30 18:55:59 +0200
commit9eb4c31eb78c28dd9f72d1cbb940270311be343c (patch)
treeea3078bc1b002a9f948ed41445ca32318002a1d3 /tests/tail-2/infloop-1.sh
parent00f5ba15dd91a3d9780fe1fbd06a4df436ae6714 (diff)
downloadcoreutils-9eb4c31eb78c28dd9f72d1cbb940270311be343c.tar.xz
tests: add .sh and .pl suffixes to shell and perl tests, respectively
Not only this shrinks the size of the generated Makefile (from > 6300 lines to ~3000), but will allow further simplifications in future changes. * tests/Makefile.am (TEST_EXTENSIONS): Add '.sh' and '.pl'. (PL_LOG_COMPILER, SH_LOG_COMPILER): New, still defined simply to $(LOG_COMPILER) for the time being. (TESTS, root_tests): Adjust as described. * All tests: Rename as described.
Diffstat (limited to 'tests/tail-2/infloop-1.sh')
-rwxr-xr-xtests/tail-2/infloop-1.sh45
1 files changed, 45 insertions, 0 deletions
diff --git a/tests/tail-2/infloop-1.sh b/tests/tail-2/infloop-1.sh
new file mode 100755
index 000000000..3f45f7741
--- /dev/null
+++ b/tests/tail-2/infloop-1.sh
@@ -0,0 +1,45 @@
+#!/bin/sh
+# This test would fail with tail from pre-1.22i textutils.
+
+# Copyright (C) 1999-2012 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ tail
+
+yes > t &
+yes_pid=$!
+while :; do
+ test -s t && break
+ sleep .1
+done
+tail -n 1 t &
+tail_pid=$!
+kill $yes_pid
+
+# This test is racy, and can fail under unusual circumstances.
+# On a very busy system, tail will fail to notice that $yes_pid is gone.
+# Then the following kill will succeed and cause this test to fail.
+
+# Wait for up to 3 seconds for tail to detect the death of $yes_pid.
+for i in $(seq 30); do
+ kill -0 $tail_pid || break
+ echo sleep 0.1s
+ sleep .1
+done
+
+kill $tail_pid && fail=1 || :
+
+Exit $fail